; "Empty" : 512 byte tune by 4mat 
; for the Tiny Sid Competition.
;
; For PAL machines, tested on 6581 chip.
;
; Source compiled with C64ASM.

*= $0801

;;;; Variables: 
;;;; Some of this data isn't used now as I removed features from the player.

voicedata = $1000 
data1 = voicedata+$15
data2 = data1+$15 
notehi = data2+$80
notelo = notehi+$80 

;;;; Basic Loader

.byte <start-1,>start,$9c,$ad,$9e,$32,$30,$36,$31,$00,$00,$00

;;;; Generate frequency table & setup player.

start sei

ldx #$00
freqloop lda #$01 
pha
txa
tay
freqset pla
sta notehi+$01,y 
asl
pha
lda freqsource,x
sta notelo+$01,y 
rol
sta freqsource,x
bcc notinc
pla
adc #$00
pha
notinc 
lda #$00
sta voicedata,y
clc
tya
adc #$0c
tay
bpl freqset
inx
cpx #$0c 
bne freqloop

ldy #$0e
sty $d418
ldx #$02
startup
lda songstart,x
sta data2+$05,y
lda #$0e
sta data1+$05,y
tya
sbc #$07
tay
dex
bne startup

;;;; Loop forever playing the tune...

wait cmp $d012
bne wait
jsr playframe
bpl wait

;;;; Player Loop.

;;;; The 2nd half of the player (update) is above the first (playframe)
;;;; to avoid branch out of range errors.

update ldy data1,x 

; pulsewidth modulation.

lda voicedata+$02,x 
adc instadd,y 
cmp voicedata+$02,x
sta voicedata+$02,x 
bcs notaddp
inc voicedata+$03,x

; load variables with note & instrument data.

notaddp tya
asl
asl
adc data1+$01,x 
sbc data1,x
tay
lda instwave,y
sta voicedata+$04,x 
lda instdata,y
cmp #$f0
bcc justset
and #$0f
adc data1+$03,x
adc data2+$02,x
tay
lda notelo,y 
sta voicedata,x
lda notehi,y 
justset sta voicedata+$01,x

; check position in instrument table and loop if required.

ignore inc data1+$01,x 
lda data1+$01,x 
and #$03
bne resetinst
ldy data1,x 
lda instpuls,y
lsr
lsr
lsr
lsr
resetinst sta data1+$01,x 

; write data to sid chip.

notnewnote ldy #$07
playsid lda voicedata,x
sta $d400,x
inx
dey
bne playsid

cpx #$15
bne loopplay 
rts

playframe ldx #$00

; check if tempo counter < 0 and reset tempo, then check if
; note length < 0 and get more pattern data if it is.

loopplay dec data2+$04,x 
bpl update

lda #$06 ; Tune Tempo
sta data2+$04,x 

dec data2,x 
bpl update

; get pattern data.

getmore inc data1+$04,x 
getmore2 ldy data1+$04,x 
lda data1+$06,x
sta data2,x
lda pattdata,y
beq notnewnote 
bmi other
sta data1+$03,x 
lda #$00
sta data1+$01,x 
ldy data1,x 
lda instpuls,y
sta voicedata+$03,x 
lda instadsr,y
sta voicedata+$06,x 
lda #$09
sta voicedata+$04,x
bpl ignore 
other cmp #$ff
beq songadd
cmp #$df
and #$0f
bcc lengthset
sta data1,x 
bpl getmore 
lengthset sta data1+$06,x 
bpl getmore 

; get song data.

songadd inc data1+$05,x
songadd2 ldy data1+$05,x 
lda songdata,y
bmi other2
sta data1+$04,x 
bpl getmore2 
other2 cmp #$ff
beq restart
and #$0f
sta data2+$02,x 
bpl songadd 
restart lda data2+$05,x 
sta data1+$05,x 
bpl songadd2

; instrument note pitches, format is:
; =<$ef     - Value to set in pitch high byte. (low byte isn't cleared). 
; =<$f0-$ff - Arpeggio value, or if $f0 play pattern data note as it is.  

instdata .byte $f3,$f7,$f0
         .byte $f4,$f7,$f0
         .byte $10,$af,$06
         .byte $f0,$f0,$f0
         .byte $14,$0c,$e0
         .byte $fc,$ef,$f0
         .byte $fc,$fc,$f0

; instrument waveform values
; I only have one counter for both data & waveform to save memory, so
; any instrument that loops can't use release value in this player. :(

instwave .byte $41,$41,$41
         .byte $41,$41,$41
         .byte $41,$81,$40
         .byte $41,$41,$40
         .byte $41,$41,$80
         .byte $11,$81,$40
         .byte $11,$21,$40

; instrument Sustain/Release settings:

instadsr .byte $6f,$6f,$95,$ec,$a9,$79,$6e 

; low 4-bits are pulsewidth hibyte, high 4-bits are instrument loop position:

instpuls .byte $15,$18,$38,$30,$38,$3b,$36 

; pulsewidth value to add each frame:

instadd  .byte $1c,$0c,$00,$15,$00,$74,$a5

; Pattern data format:
; =< $7f  - Note value. (if zero leave the previous note playing)
; $80-$8f - Set Note length.
; $e0-$ef - Set Instrument number.
; $ff     - End pattern.

pattdata 

         ; reset data
         
	 .byte $00,$ff

         ; bassline
         
         .byte $81,$e3,$11,$1d,$82,$e4,$55,$82,$e3,$11,$81,$1d
         .byte $e4,$55,$e3,$18,$ff

         ; bassdrum and accompany voice
         
         .byte $e2,$55,$e5,$30,$35,$3a,$41,$35,$3a,$29,$ff

         ; arpeggio
         
         .byte $8f,$e0,$35,$e1,$33,$31,$00,$e0,$35,$e1,$33,$e0,$2e,$00,$ff
         
         ; riff
         
         .byte $e6,$82,$38,$37,$87,$ff
         .byte $33,$80,$2e,$2c,$ff
         .byte $31,$8f,$00,$81,$00,$ff
         .byte $8f,$2e,$00,$ff
         
; Song data format:
; =< $7f  - Position in pattern data to play from.
; $80-$8f - Tranpose value for this channel.
; I removed the 'repeat pattern' command and made the maximum 
; patterndata 128 bytes to save some memory.

songdata 

         ; channel 1
         
         .byte $f0,$02,$02,$f5,$02,$02,$f8,$02,$fa,$02,$f1,$02,$02,$ff 

         ; channel 2
         
         .byte $13,$ff

         ; channel 3
         
         .byte $1e,$1e
         .byte $2d,$33,$2d,$33,$2d,$38 
         .byte $2d,$33,$2d,$33,$3e
         .byte $2d,$f7,$33,$f0,$2d,$f9,$33,$f0,$2d,$38
         .byte $2d,$33,$2d,$33,$3e,$ff
         
; start positions in the songdata for each channel.

songstart .byte $00,$0e,$10

; source values used to calculate frequency table.  

freqsource  .byte 12,28,45,62,81,102,123,145,169,195,221,250

